Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/CyclicCrossoverTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/CyclicCrossoverTest.cs	(revision 2854)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/CyclicCrossoverTest.cs	(revision 2854)
@@ -0,0 +1,145 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Permutation;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Permutation.Tests {
+
+
+  /// <summary>
+  ///This is a test class for CyclicCrossover and is intended
+  ///to contain all CyclicCrossover Unit Tests
+  ///</summary>
+  [TestClass()]
+  public class CyclicCrossoverTest {
+
+
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    #region Additional test attributes
+    // 
+    //You can use the following additional attributes as you write your tests:
+    //
+    //Use ClassInitialize to run code before running the first test in the class
+    //[ClassInitialize()]
+    //public static void MyClassInitialize(TestContext testContext)
+    //{
+    //}
+    //
+    //Use ClassCleanup to run code after all tests in a class have run
+    //[ClassCleanup()]
+    //public static void MyClassCleanup()
+    //{
+    //}
+    //
+    //Use TestInitialize to run code before running each test
+    //[TestInitialize()]
+    //public void MyTestInitialize()
+    //{
+    //}
+    //
+    //Use TestCleanup to run code after each test has run
+    //[TestCleanup()]
+    //public void MyTestCleanup()
+    //{
+    //}
+    //
+    #endregion
+
+
+    /// <summary>
+    ///A test for Cross
+    ///</summary>
+    [TestMethod()]
+    [DeploymentItem("HeuristicLab.Permutation-3.3.dll")]
+    public void CyclicCrossoverCrossTest() {
+      TestRandom random = new TestRandom();
+      CyclicCrossover_Accessor target =
+        new CyclicCrossover_Accessor(new PrivateObject(typeof(CyclicCrossover)));
+      // perform a test with more than two parents
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        target.Cross(random, new ItemArray<Permutation>(new Permutation[] { 
+          new Permutation(4), new Permutation(4), new Permutation(4)}));
+      }
+      catch (System.InvalidOperationException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for Apply
+    ///</summary>
+    [TestMethod()]
+    public void CyclicCrossoverApplyTest() {
+      TestRandom random = new TestRandom();
+      Permutation parent1, parent2, expected, actual;
+      // The following test is based on an example from Larranaga, P. et al. 1999. Genetic Algorithms for the Travelling Salesman Problem: A Review of Representations and Operators. Artificial Intelligence Review, 13
+      random.Reset();
+      random.DoubleNumbers = new double[] { 0.9 };
+      parent1 = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7 });
+      Assert.IsTrue(parent1.Validate());
+      parent2 = new Permutation(new int[] { 1, 3, 5, 7, 6, 4, 2, 0 });
+      Assert.IsTrue(parent2.Validate());
+      expected = new Permutation(new int[] { 0, 1, 5, 3, 6, 4, 2, 7 });
+      Assert.IsTrue(expected.Validate());
+      actual = CyclicCrossover.Apply(random, parent1, parent2);
+      Assert.IsTrue(actual.Validate());
+      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, actual));
+     
+      // perform a test when the two permutations are of unequal length
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        CyclicCrossover.Apply(random, new Permutation(8), new Permutation(6));
+      }
+      catch (System.ArgumentException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for OrderCrossover Constructor
+    ///</summary>
+    [TestMethod()]
+    public void CyclicCrossoverConstructorTest() {
+      CyclicCrossover target = new CyclicCrossover();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/EdgeRecombinationCrossoverTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/EdgeRecombinationCrossoverTest.cs	(revision 2854)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/EdgeRecombinationCrossoverTest.cs	(revision 2854)
@@ -0,0 +1,146 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Permutation;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Permutation.Tests {
+
+
+  /// <summary>
+  ///This is a test class for EdgeRecombinationCrossover and is intended
+  ///to contain all EdgeRecombinationCrossover Unit Tests
+  ///</summary>
+  [TestClass()]
+  public class EdgeRecombinationCrossoverTest {
+
+
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    #region Additional test attributes
+    // 
+    //You can use the following additional attributes as you write your tests:
+    //
+    //Use ClassInitialize to run code before running the first test in the class
+    //[ClassInitialize()]
+    //public static void MyClassInitialize(TestContext testContext)
+    //{
+    //}
+    //
+    //Use ClassCleanup to run code after all tests in a class have run
+    //[ClassCleanup()]
+    //public static void MyClassCleanup()
+    //{
+    //}
+    //
+    //Use TestInitialize to run code before running each test
+    //[TestInitialize()]
+    //public void MyTestInitialize()
+    //{
+    //}
+    //
+    //Use TestCleanup to run code after each test has run
+    //[TestCleanup()]
+    //public void MyTestCleanup()
+    //{
+    //}
+    //
+    #endregion
+
+
+    /// <summary>
+    ///A test for Cross
+    ///</summary>
+    [TestMethod()]
+    [DeploymentItem("HeuristicLab.Permutation-3.3.dll")]
+    public void EdgeRecombinationCrossoverCrossoverCrossTest() {
+      TestRandom random = new TestRandom();
+      EdgeRecombinationCrossover_Accessor target =
+        new EdgeRecombinationCrossover_Accessor(new PrivateObject(typeof(EdgeRecombinationCrossover)));
+      // perform a test with more than two parents
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        target.Cross(random, new ItemArray<Permutation>(new Permutation[] { 
+          new Permutation(4), new Permutation(4), new Permutation(4)}));
+      }
+      catch (System.InvalidOperationException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for Apply
+    ///</summary>
+    [TestMethod()]
+    public void EdgeRecombinationCrossoverApplyTest() {
+      TestRandom random = new TestRandom();
+      Permutation parent1, parent2, expected, actual;
+      // The following test is based on an example from Eiben, A.E. and Smith, J.E. 2003. Introduction to Evolutionary Computation. Natural Computing Series, Springer-Verlag Berlin Heidelberg, pp. 54-55
+      random.Reset();
+      random.IntNumbers = new int[] { 0 };
+      random.DoubleNumbers = new double[] { 0.5, 0, 0, 0 };
+      parent1 = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7, 8 });
+      Assert.IsTrue(parent1.Validate());
+      parent2 = new Permutation(new int[] { 8, 2, 6, 7, 1, 5, 4, 0, 3 });
+      Assert.IsTrue(parent2.Validate());
+      expected = new Permutation(new int[] { 0, 4, 5, 1, 7, 6, 2, 8, 3 });
+      Assert.IsTrue(expected.Validate());
+      actual = EdgeRecombinationCrossover.Apply(random, parent1, parent2);
+      Assert.IsTrue(actual.Validate());
+      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, actual));
+     
+      // perform a test when the two permutations are of unequal length
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        EdgeRecombinationCrossover.Apply(random, new Permutation(8), new Permutation(6));
+      }
+      catch (System.ArgumentException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for EdgeRecombinationCrossover Constructor
+    ///</summary>
+    [TestMethod()]
+    public void EdgeRecombinationCrossoverConstructorTest() {
+      EdgeRecombinationCrossover target = new EdgeRecombinationCrossover();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/HeuristicLab.Permutation-3.3.Tests.csproj
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/HeuristicLab.Permutation-3.3.Tests.csproj	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/HeuristicLab.Permutation-3.3.Tests.csproj	(revision 2854)
@@ -42,8 +42,23 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="AbsolutePositionTopologicalCrossoverTest.cs" />
     <Compile Include="Auxiliary.cs" />
+    <Compile Include="CosaCrossoverTest.cs" />
+    <Compile Include="CyclicCrossoverTest.cs" />
+    <Compile Include="EdgeRecombinationCrossoverTest.cs" />
+    <Compile Include="InsertionManipulatorTest.cs" />
+    <Compile Include="InversionManipulatorTest.cs" />
+    <Compile Include="MaximalPreservativeCrossoverTest.cs" />
+    <Compile Include="OrderBasedCrossoverTest.cs" />
     <Compile Include="OrderCrossoverTest.cs" />
+    <Compile Include="PartiallyMatchedCrossoverTest.cs" />
+    <Compile Include="PositionBasedCrossoverTest.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Random.cs" />
+    <Compile Include="ScrambleManipulatorTest.cs" />
+    <Compile Include="Swap2ManipulatorTest.cs" />
+    <Compile Include="Swap3ManipulatorTest.cs" />
+    <Compile Include="TranslocationInversionManipulatorTest.cs" />
+    <Compile Include="TranslocationManipulatorTest.cs" />
   </ItemGroup>
   <ItemGroup>
Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/InsertionManipulatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/InsertionManipulatorTest.cs	(revision 2854)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/InsertionManipulatorTest.cs	(revision 2854)
@@ -0,0 +1,122 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Permutation;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Permutation.Tests {
+
+
+  /// <summary>
+  ///This is a test class for InsertionManipulator and is intended
+  ///to contain all InsertionManipulator Unit Tests
+  ///</summary>
+  [TestClass()]
+  public class InsertionManipulatorTest {
+
+
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    #region Additional test attributes
+    // 
+    //You can use the following additional attributes as you write your tests:
+    //
+    //Use ClassInitialize to run code before running the first test in the class
+    //[ClassInitialize()]
+    //public static void MyClassInitialize(TestContext testContext)
+    //{
+    //}
+    //
+    //Use ClassCleanup to run code after all tests in a class have run
+    //[ClassCleanup()]
+    //public static void MyClassCleanup()
+    //{
+    //}
+    //
+    //Use TestInitialize to run code before running each test
+    //[TestInitialize()]
+    //public void MyTestInitialize()
+    //{
+    //}
+    //
+    //Use TestCleanup to run code after each test has run
+    //[TestCleanup()]
+    //public void MyTestCleanup()
+    //{
+    //}
+    //
+    #endregion
+
+
+    /// <summary>
+    ///A test for Apply
+    ///</summary>
+    [TestMethod()]
+    public void InsertionManipulatorApplyTest() {
+      TestRandom random = new TestRandom();
+      Permutation parent, expected;
+      // The following test is based on an example from Larranaga, P. et al. 1999. Genetic Algorithms for the Travelling Salesman Problem: A Review of Representations and Operators. Artificial Intelligence Review, 13
+      random.Reset();
+      random.IntNumbers = new int[] { 3, 6 };
+      parent = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7 });
+      Assert.IsTrue(parent.Validate());
+      
+      expected = new Permutation(new int[] { 0, 1, 2, 4, 5, 6, 3, 7 });
+      Assert.IsTrue(expected.Validate());
+      InsertionManipulator.Apply(random, parent);
+      Assert.IsTrue(parent.Validate());
+      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, parent));
+     
+      // perform a test when the two permutations are of unequal length
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        CyclicCrossover.Apply(random, new Permutation(8), new Permutation(6));
+      }
+      catch (System.ArgumentException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for InsertionManipulator Constructor
+    ///</summary>
+    [TestMethod()]
+    public void InsertionManipulatorConstructorTest() {
+      InsertionManipulator target = new InsertionManipulator();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/InversionManipulatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/InversionManipulatorTest.cs	(revision 2854)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/InversionManipulatorTest.cs	(revision 2854)
@@ -0,0 +1,122 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Permutation;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Permutation.Tests {
+
+
+  /// <summary>
+  ///This is a test class for InversionManipulator and is intended
+  ///to contain all InversionManipulator Unit Tests
+  ///</summary>
+  [TestClass()]
+  public class InversionManipulatorTest {
+
+
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    #region Additional test attributes
+    // 
+    //You can use the following additional attributes as you write your tests:
+    //
+    //Use ClassInitialize to run code before running the first test in the class
+    //[ClassInitialize()]
+    //public static void MyClassInitialize(TestContext testContext)
+    //{
+    //}
+    //
+    //Use ClassCleanup to run code after all tests in a class have run
+    //[ClassCleanup()]
+    //public static void MyClassCleanup()
+    //{
+    //}
+    //
+    //Use TestInitialize to run code before running each test
+    //[TestInitialize()]
+    //public void MyTestInitialize()
+    //{
+    //}
+    //
+    //Use TestCleanup to run code after each test has run
+    //[TestCleanup()]
+    //public void MyTestCleanup()
+    //{
+    //}
+    //
+    #endregion
+
+
+    /// <summary>
+    ///A test for Apply
+    ///</summary>
+    [TestMethod()]
+    public void InversionManipulatorApplyTest() {
+      TestRandom random = new TestRandom();
+      Permutation parent, expected;
+      // The following test is based on an example from Eiben, A.E. and Smith, J.E. 2003. Introduction to Evolutionary Computation. Natural Computing Series, Springer-Verlag Berlin Heidelberg, pp. 46-47
+      random.Reset();
+      random.IntNumbers = new int[] { 1, 4 };
+      parent = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7, 8 });
+      Assert.IsTrue(parent.Validate());
+      
+      expected = new Permutation(new int[] { 0, 4, 3, 2, 1, 5, 6, 7, 8 });
+      Assert.IsTrue(expected.Validate());
+      InversionManipulator.Apply(random, parent);
+      Assert.IsTrue(parent.Validate());
+      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, parent));
+     
+      // perform a test when the two permutations are of unequal length
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        CyclicCrossover.Apply(random, new Permutation(8), new Permutation(6));
+      }
+      catch (System.ArgumentException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for InversionManipulator Constructor
+    ///</summary>
+    [TestMethod()]
+    public void InversionManipulatorConstructorTest() {
+      InversionManipulator target = new InversionManipulator();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/MaximalPreservativeCrossoverTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/MaximalPreservativeCrossoverTest.cs	(revision 2854)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/MaximalPreservativeCrossoverTest.cs	(revision 2854)
@@ -0,0 +1,145 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Permutation;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Permutation.Tests {
+
+
+  /// <summary>
+  ///This is a test class for MaximalPreservativeCrossover and is intended
+  ///to contain all MaximalPreservativeCrossover Unit Tests
+  ///</summary>
+  [TestClass()]
+  public class MaximalPreservativeCrossoverTest {
+
+
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    #region Additional test attributes
+    // 
+    //You can use the following additional attributes as you write your tests:
+    //
+    //Use ClassInitialize to run code before running the first test in the class
+    //[ClassInitialize()]
+    //public static void MyClassInitialize(TestContext testContext)
+    //{
+    //}
+    //
+    //Use ClassCleanup to run code after all tests in a class have run
+    //[ClassCleanup()]
+    //public static void MyClassCleanup()
+    //{
+    //}
+    //
+    //Use TestInitialize to run code before running each test
+    //[TestInitialize()]
+    //public void MyTestInitialize()
+    //{
+    //}
+    //
+    //Use TestCleanup to run code after each test has run
+    //[TestCleanup()]
+    //public void MyTestCleanup()
+    //{
+    //}
+    //
+    #endregion
+
+
+    /// <summary>
+    ///A test for Cross
+    ///</summary>
+    [TestMethod()]
+    [DeploymentItem("HeuristicLab.Permutation-3.3.dll")]
+    public void CyclicCrossoverCrossTest() {
+      TestRandom random = new TestRandom();
+      MaximalPreservativeCrossover_Accessor target =
+        new MaximalPreservativeCrossover_Accessor(new PrivateObject(typeof(MaximalPreservativeCrossover)));
+      // perform a test with more than two parents
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        target.Cross(random, new ItemArray<Permutation>(new Permutation[] { 
+          new Permutation(4), new Permutation(4), new Permutation(4)}));
+      }
+      catch (System.InvalidOperationException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for Apply
+    ///</summary>
+    [TestMethod()]
+    public void MaximalPreservativeCrossoverApplyTest() {
+      TestRandom random = new TestRandom();
+      Permutation parent1, parent2, expected, actual;
+      // The following test is based on an example from Larranaga, 1999. Genetic Algorithms for the Traveling Salesman Problem.
+      random.Reset();
+      random.IntNumbers = new int[] { 3, 2 };
+      parent1 = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7 });
+      Assert.IsTrue(parent1.Validate());
+      parent2 = new Permutation(new int[] { 1, 3, 5, 7, 6, 4, 2, 0 });
+      Assert.IsTrue(parent2.Validate());
+      expected = new Permutation(new int[] { 1, 0, 2, 3, 4, 5, 7, 6 });
+      Assert.IsTrue(expected.Validate());
+      actual = MaximalPreservativeCrossover.Apply(random, parent1, parent2);
+      Assert.IsTrue(actual.Validate());
+      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, actual));
+     
+      // perform a test when the two permutations are of unequal length
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        MaximalPreservativeCrossover.Apply(random, new Permutation(8), new Permutation(6));
+      }
+      catch (System.ArgumentException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for OrderCrossover Constructor
+    ///</summary>
+    [TestMethod()]
+    public void MaximalPreservativeCrossoverConstructorTest() {
+      MaximalPreservativeCrossover target = new MaximalPreservativeCrossover();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/OrderBasedCrossoverTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/OrderBasedCrossoverTest.cs	(revision 2854)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/OrderBasedCrossoverTest.cs	(revision 2854)
@@ -0,0 +1,142 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Permutation;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Permutation.Tests
+{
+    
+    
+    /// <summary>
+    ///This is a test class for OrderBasedCrossoverTest and is intended
+    ///to contain all OrderBasedCrossoverTest Unit Tests
+    ///</summary>
+  [TestClass()]
+  public class OrderBasedCrossoverTest {
+
+
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    #region Additional test attributes
+    // 
+    //You can use the following additional attributes as you write your tests:
+    //
+    //Use ClassInitialize to run code before running the first test in the class
+    //[ClassInitialize()]
+    //public static void MyClassInitialize(TestContext testContext)
+    //{
+    //}
+    //
+    //Use ClassCleanup to run code after all tests in a class have run
+    //[ClassCleanup()]
+    //public static void MyClassCleanup()
+    //{
+    //}
+    //
+    //Use TestInitialize to run code before running each test
+    //[TestInitialize()]
+    //public void MyTestInitialize()
+    //{
+    //}
+    //
+    //Use TestCleanup to run code after each test has run
+    //[TestCleanup()]
+    //public void MyTestCleanup()
+    //{
+    //}
+    //
+    #endregion
+
+
+    /// <summary>
+    ///A test for Cross
+    ///</summary>
+    [TestMethod()]
+    [DeploymentItem("HeuristicLab.Permutation-3.3.dll")]
+    public void OrderBasedCrossoverCrossTest() {
+      TestRandom random = new TestRandom();
+      OrderBasedCrossover_Accessor target = 
+        new OrderBasedCrossover_Accessor(new PrivateObject(typeof(OrderBasedCrossover)));
+      // perform a test with more than two parents
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        target.Cross(random, new ItemArray<Permutation>(new Permutation[] { 
+          new Permutation(4), new Permutation(4), new Permutation(4)}));
+      } catch (System.InvalidOperationException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for Apply
+    ///</summary>
+    [TestMethod()]
+    public void OrderBasedCrossoverApplyTest() {
+      TestRandom random = new TestRandom();
+      Permutation parent1, parent2, expected, actual;
+      // The following test is based on an example from Larranaga, P. et al. 1999. Genetic Algorithms for the Travelling Salesman Problem: A Review of Representations and Operators. Artificial Intelligence Review, 13
+      random.Reset();
+      random.IntNumbers = new int[] { 3, 5, 2, 1 };
+      parent1 = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7 });
+      Assert.IsTrue(parent1.Validate());
+      parent2 = new Permutation(new int[] { 1, 3, 5, 7, 6, 4, 2, 0 });
+      Assert.IsTrue(parent2.Validate());
+      expected = new Permutation(new int[] { 1, 3, 2, 7, 6, 4, 5, 0 });
+      actual = OrderBasedCrossover.Apply(random, parent1, parent2);
+      Assert.IsTrue(actual.Validate());
+      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, actual));
+      // perform a test when the two permutations are of unequal length
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        OrderBasedCrossover.Apply(random, new Permutation(8), new Permutation(6));
+      } catch (System.ArgumentException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for OrderBasedCrossover Constructor
+    ///</summary>
+    [TestMethod()]
+    public void OrderBasedCrossoverConstructorTest() {
+      OrderBasedCrossover target = new OrderBasedCrossover();
+    }
+  }
+}
